# -*- coding: utf-8 -*-
# tspGraphApp.py

from grafikfenster import *
from tspGAKlasse import *

fg,bg='black','white'
# fuer schwarzen Hintergrund umstellen:
##fg,bg='white','black'

### ---------------------------------------------------
class tspGraph():
    """Klasse zum Zeichnen des Graphen"""
    
    def __init__(self):
        """einfacher Konstruktor"""
        self.daten=[]
        
    def GibFigur(self):
        """definiert und transformiert die zu zeichnende Figur"""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        path = gc.CreatePath()
        path.MoveToPoint(self.daten[len(self.daten)-1])
        for ort in self.daten:
            path.AddLineToPoint(ort[0], ort[1])
        return path

    def setzeDaten(self, daten):
        """Veraendernde Methode fuer die Daten"""
        self.Verberge()
        self.daten = daten
        self.Zeige()

    def GibFarbe(self):
        return fg

    def Verberge(self):
        """Veraendernde Methode fuer die Sichtbarkeit mit Wert False"""
        Zeichenflaeche.GibZeichenflaeche().Entferne(self)

    def Zeige(self):
        """Veraendernde Methode fuer die Sichtbarkeit mit Wert True"""
        Zeichenflaeche.GibZeichenflaeche().Zeichne(self)

### ---------------------------------------------------
from schritte import Schritte
class tspGraphApp(wx.App):
    
    def OnInit(self):
        self.fenster = GrafikFenster(None, "Grafik")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        self.fenster.panel.Refresh()
        self.fenster.ZeigeShellFrame()
        #self.fenster.ZeigeFillingFrame()
        self.graph=tspGraph()
        zf=Zeichenflaeche.GibZeichenflaeche()
        zf.Setze_fg_bg(fg,bg)
        self.tspga = TSPGA()
        self.daten=[]
        self.TestAnwendung()
        print('Bildexport mit "app.BildExport()" im ShellFrame')
        return True

    def TestAnwendung(self):
        """Zeigt jeweils die besten Touren"""
        global schritte
        staedteListe=self.tspga.erzeugeAlleStaedte(10)
        self.tspga.genetischerAlgorithmus(30, 100, 50, 30) # hier steuern!
        ## Population,Schritte,P(Mutation),P(crossingOver)
        self.daten = self.tspga.gibSchrittDaten()
        self.schritte=Schritte(self, len(self.daten), self.einSchritt)
        self.schritte.Start(500)

    def einSchritt(self):
        self.graph.setzeDaten(self.daten[self.schritte.GibN()-1][0])
        ##print(self.schritte.GibN(), self.daten[self.schritte.GibN()-1][1])
        
    def BildExport(self):
        Zeichenflaeche.GibZeichenflaeche().BildExport('Bild.png')
        
### ---------------------------------------------------
if __name__ == '__main__':
    app = tspGraphApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
